org.cpsolver.instructor.criteria

## Class InstructorSchedulingCriterion

- java.lang.Object
- - org.cpsolver.ifs.criteria.AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>
  - - org.cpsolver.instructor.criteria.InstructorSchedulingCriterion

- All Implemented Interfaces:
    CanHoldContext, HasAssignmentContext<TeachingRequest.Variable,TeachingAssignment,AbstractCriterion.ValueContext>, Criterion<TeachingRequest.Variable,TeachingAssignment>, ExtendedInfoProvider<TeachingRequest.Variable,TeachingAssignment>, InfoProvider<TeachingRequest.Variable,TeachingAssignment>, ModelListener<TeachingRequest.Variable,TeachingAssignment>
  Direct Known Subclasses:
    AttributePreferences, BackToBack, CoursePreferences, DifferentLecture, Distributions, InstructorPreferences, OriginalInstructor, SameCommon, SameCourse, SameDays, SameInstructor, SameLink, SameRoom, TeachingPreferences, TimeOverlaps, TimePreferences, UnusedInstructorLoad

      public abstract class InstructorSchedulingCriterion
      extends AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>

  Abstract instructor scheduling criterion. Implementing `InfoProvider.getInfo(Assignment, Map)` and a few other methods.
  Version:
    IFS 1.3 (Instructor Sectioning)
    Copyright (C) 2016 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueContext, AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iWeight, sDoubleFormat, sPercentFormat`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InstructorSchedulingCriterion()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Set<Instructor>` | `getAssignedInstructors(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Collection<TeachingRequest.Variable> variables)` Assigned instructors of a sub-problem
    `void` | `getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Map<String,String> info)` Adds some information into the table with information about the solution
    `void` | `getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Map<String,String> info, Collection<TeachingRequest.Variable> variables)` Adds some information into the table with information about the solution, only consider variables from the given set
    `Set<Instructor>` | `getInstructors(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Collection<TeachingRequest.Variable> variables)` Instructor of a sub-problem

    - ### Methods inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, computeBounds, configure, constraintAdded, constraintRemoved, createAssignmentContext, getAbbreviation, getAssignmentContextReference, getBest, getBounds, getBounds, getBounds, getBounds, getContext, getContext, getExtendedInfo, getModel, getName, getPerc, getPercentage, getPercRev, getValue, getValue, getValue, getValue, getValueUpdateType, getWeight, getWeightDefault, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, inc, init, setAssignmentContextReference, setModel, setValueUpdateType, toString, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.cpsolver.ifs.criteria.Criterion

      `getValue`

- - ### Constructor Detail

    - #### InstructorSchedulingCriterion

          public InstructorSchedulingCriterion()

  - ### Method Detail

    - #### getInfo

          public void getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                              Map<String,String> info)

      Description copied from interface: `InfoProvider`
      Adds some information into the table with information about the solution
      Specified by:
        `getInfo` in interface `InfoProvider<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getInfo` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `assignment` - current assignment
        `info` - info table

    - #### getInfo

          public void getInfo(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                              Map<String,String> info,
                              Collection<TeachingRequest.Variable> variables)

      Description copied from interface: `InfoProvider`
      Adds some information into the table with information about the solution, only consider variables from the given set
      Specified by:
        `getInfo` in interface `InfoProvider<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getInfo` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `assignment` - current assignment
        `info` - info table
        `variables` - sub-problem

    - #### getInstructors

          public Set<Instructor> getInstructors(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                                Collection<TeachingRequest.Variable> variables)

      Instructor of a sub-problem
      Parameters:
        `assignment` - current instructors
        `variables` - sub-problem
      Returns:
        instructors that can be used by the given teaching requests

    - #### getAssignedInstructors

          public Set<Instructor> getAssignedInstructors(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                                        Collection<TeachingRequest.Variable> variables)

      Assigned instructors of a sub-problem
      Parameters:
        `assignment` - current instructors
        `variables` - sub-problem
      Returns:
        instructors that can be used by the given teaching requests